
/* Programma che verr chiamato in pipe con "ls -l" per filtrare i file con determinate caratteristiche.

   "argc" conta gli argomenti passati. E' sempre maggiore di zero, perche' il primo argomento e' sempre
   il comando usato per chiamare il programma.
   "*argv[] e' un vettore di stringhe. Il primo argomento e' il nome del programma, poi quello che scrivo.*/


#include<stdio.h>
#include<stdlib.h>
#include<string.h>

void filtramesi(char *mese);


int main(int argc, char **argv)
{
	if (argc<3)
	{
		printf("Errore: mancano parametri!\n");
		exit(-1);
	}

/* La funzione strcmp, string compair accetta come parametri due sringhe e restituisce:
     0          se le stringhe sono uguali
    <0          se la prima stringa precede, in ordine alfabetico, la seconda
    >0          se la seconda stringa precede, in ordine alfabetico, la prima

    !!!! Le lettere MAIUSCOLE precedono le minuscole.
    !!!! Ciao != ciao per case sensitive.
*/

	if(strcmp(argv[1], "-m") == 0)
	{
		filtramesi(argv[2]);
	}
	/* else if(strcmp(argv[1], "-n") == 0)
	{
		filtranomi(argv[2]);
	}  */
	else
	{
		printf("Errore: opzione non riconosciuta!\n");
		exit(-1);
	}
	return 0;
}
/* Questa e' la procedura standard quando si opera con parametri passati dall'utente:
   prima si controlla l'esattezza del numero dei parametri passati, poi, se possibile, si effettuano le
   operazioni richieste.
   !!!All'esame dovrai fare questo!!!!
*/

/* Per leggere una riga alla wolta uso la funzione fgets(char s[], sizeof(s), stdin).
   Quando finisce le stringhe ritorna NULL.
   per esrapolare informazioni da una stringa uso la sscanf(stringa, "%i %s", &day, &month)
*/
void filtramesi(char *mese)
{
	char s[100];
	char xx[100], prop[100], group[100], mese1[10], ora[10], nome[20];
	int n, dim, gg;
	fgets(s, sizeof(s), stdin);      /* Questa serve per acquisire e non elaborare la prima stringa, che contiene il tot. file*/
	while(fgets(s, sizeof(s), stdin) != NULL)
	{
		fgets(s, sizeof(s), stdin);
		sscanf(s,"%s %i %s %s %i %s %i %s %s", xx, &n, prop, group, &dim, mese1, &gg, ora, nome);
		if(strstr(mese1, mese) != NULL)
			puts(s);
	}
}


