/*
 * horse_race.c
 * --- CORSA DI CAVALLI ---
 * Il programma simula una corsa di 5 cavalli.
 * L'utente scommette sul cavallo vincente.
 *
 * SVOLGIMENTO DELLA CORSA
 * Ad ogni turno si calcola la posizione di ciascun cavallo sommando un
 * numero random da 1 a STEP, finche` almeno un cavallo raggiunge il
 * traguardo (GOAL).
 * A questo punto il cavallo che ha percorso piu` strada e` il vincitore.
 *
 * Author: Marco Della Vedova - University of Pavia
 * Update: Mar.21, 2013
 */
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>

#define GOAL 70 /* La distanza del traguardo */
#define STEP 5 /* La massima distanza percorribile in un turno */

/* Funzione per pulire lo schermo. Usa un *escape char*. */
void clear()
{
	printf("\033[H\033[2J");
	return;
}

/* Stampa la posizione *p* del cavallo *index*, all'interno del percorso.
 * Ad esempio, se p=3, index=5, GOAL=10, verra` stampata la stringa seguente:
 * "  5       |\n"
 */
void print_pos( int p, int index )
{
	/*** TODO ***fatto***/
	int i = 0;
	while(i <= GOAL)
	{
		if(i != p)
		{
			printf(" ");
		}
		else
		{
			printf("%i", index);
		}
		i = i + 1;
	}
	printf("|");
	if(p > GOAL)
	{
		printf("%i", index);
	}
	printf("\n");
}

/* Trova il massimo tra i valori di c1,c2,c3,c4,c5 e restituisce il
 * rispettivo indice.
 */
int find_winner( int c1, int c2, int c3, int c4, int c5 )
{
	/*** TODO ***fatto***/
	int max, win;
	max = c1;
	win = 1;
	if(c2 > max)
	{
		max = c2;
		win = 2;
	}
	if(c3 > max)
	{
		max = c3;
		win = 3;
	}
	if(c4 > max)
	{
		max = c4;
		win = 4;
	}
	if(c5 > max)
	{
		max = c5;
		win = 5;
	}
	return win;
}

int main()
{
	int bet; /* il cavallo su cui si scommette */
	int winner=0; /* il cavallo vincitore */
	int c1=0, c2=0, c3=0, c4=0, c5=0;
	/* cX e` la distanza percorsa dal cavallo n. X */

	/* Richiesta inserimento scommessa */
	/*** TODO ***fatto***/
	printf("Inserire il cavallo vincente (1 to 5):\n");
	scanf("%i", &bet);
	if(bet<1 || bet>5)
	{
		printf("Errore nella scommessa: il valore deve essere 1 to 5\n");
		return -1;
	}

	srand( time(NULL) ); /* inizializzazione del generatore di numeri casuali */

	/* Ciclo che incrementa la posizione dei cavalli */
	do{
		/* I cavalli si muovono. rand() restituisce un int casuale */
		/*** TODO ***fatto***/
		c1 = c1 + 1 + rand()%STEP;
		c2 = c2 + 1 + rand()%STEP;
		c3 = c3 + 1 + rand()%STEP;
		c4 = c4 + 1 + rand()%STEP;
		c5 = c5 + 1 + rand()%STEP;

		/* Stampo a video le varie posizioni */
		clear();
		print_pos(c1, 1);
		print_pos(c2, 2);
		print_pos(c3, 3);
		print_pos(c4, 4);
		print_pos(c5, 5);
		printf("You betted on...%i\n", bet);

		/* Controllo se c'e` un vincitore */
		/*** TODO ***fatto***/
		if(c1 > GOAL || c2 > GOAL || c3 > GOAL || c4 > GOAL || c5 > GOAL)
		{
			winner = find_winner(c1, c2, c3, c4, c5);
		}
		usleep(500000); /* Metto in pausa il programma per 500000 microsec
		                 * in modo da poter "vedere" cosa succede */
	}while( winner == 0 );


	/* Stampo le informazioni finali e esco */
	/*** TODO ***/
	printf("The WINNER is...%i\n", winner);
	if(winner == bet)
	printf("Hai vinto, ma il tuo allibratore e' fuggito con i soldi...\n");
	else
	printf("Hai perso, sfigatto!\n");
	return 0;
}
